Hello, people…! In this post, I will talk about one of the fastest single source shortest path algorithms, which is, the Dijkstra’s Algorithm. The Dijkstra’s Algorithm works on a weighted graph with non-negative edge weights and gives a Shortest Path Tree. It is a greedy algorithm, which sort of mimics the working of breadth first search and depth first search.

The Dijkstra’s Algorithm starts with a source vertex ‘**s**‘ and explores the whole graph. We will use the following elements to compute the shortest paths –

- Priority Queue
**Q**.
- An array
**D**, which keeps the record of the total distance from starting vertex **s** to all other vertices.

Just like the other graph search algorithms, Dijkstra’s Algorithm is best understood by listing out the algorithm in a step-by-step process –

**D[s]**, which is the shortest distance to **s** is set to 0. The distance from the source to itself is 0.
- For all the other vertices
**V**, **D[V]** is set to infinity as we do not have a path yet to them, so we simply say that the distance to them is infinity.
- The Priority Queue
**Q**, is constructed which is initially holds all the vertices of the graph. Each vertex **V** will have the priority **D[V]**.

- Now, pick up the minimum priority (D[V]) element from
**Q** (which removes it from **Q**). For the first time, this operation would obviously give **s**.
- For all the vertices,
**v**, adjacent to **s**, i.e., check if the edge from **s** → **v** gives a shorter path. This is done by checking the following condition –
if, **D[s]** + (weight of edge **s** → **v**) < **D[v]**, we found a new shorter route, so update **D[v]**

**D[v]** = **D[s]** + (weight of edge **s** → **v**)

- Now pick the next minimum priority element from
**Q**, and repeat the process until there are no elements left in **Q**.

Let us understand this with the help of an example. Consider the graph below –

Firstly, initialize your components, the shortest distances array **D**, the priority queue **Q.** The distance from the source to itself is zero. So, **D[s]** = 0, and the rest of the array is ∞. The set of vertices **v **is inserted into the priority queue **Q**, with a priority **D[v]**. Now, we start our algorithm by extracting the minimum element from the priority queue.

The minimum element in the priority queue will definitely be **s** (which is A here). Look at all the adjacent vertices of A. Vertices B, C, D are adjacent to A. We can go to B travelling the edge of weight 2, to C travelling an edge of weight 1, to D travelling an edge of weight 5. The values of **D[B]**, **D[C]**, **D[D]** are ∞ . We have found a new way of reaching them in 2, 1, 5 units respectively, which is less than ∞, hence a shorter path. This is what the if-condition mentioned above does. So, we update the values of **D[B]**, **D[C]**, **D[D]** and the priorities of B, C, D, in the priority queue. With this, we have finished processing the vertex A.

Now, the process continues to its next iteration and we extract the minimum element from the priority queue. The minimum element would be vertex C which would be having a priority of 1. Now, look at all the adjacent vertices to C. There’s vertex D. From C, it would take 1 unit of distance to reach D. But to reach C in prior, you need 1 more unit of distance. So, if you go to D, via C, the total distance would be 2 units, which is less than the current value of shortest distance discovered to D, **D[D]** = 5. So, we reduce the value of **D[D]** to 2. This reduction is also called as “**Relaxation**“. With that, we’re done with vertex C.

Now, the process continues to its next iteration and we extract the minimum element from the priority queue. Now, there are two minimum elements, B and D. You can go for anyone. We will go for vertex D. From D, you can go to E and F, with a total distance of 2 + 2 {**D[D]** + (weight of D → E)}, and 2 + 3. Which is less than ∞, so **D[E]** becomes 4 and **D[F]** becomes 5. We’re done with vertex D.

Now, the process continues to its next iteration and we extract the minimum element from the priority queue. The minimum element in the priority queue is vertex B. From vertex B, you can reach F in 2 + 1 units of distance, which is less than the current value of **D[F]**, 5. So, we relax **D**(F) to 3. From vertex B, you can reach vertex D in 2 + 2 units of distance, which is more than the current value of **D**(D), 2. This route is not considered as it is clearly proven to be a longer route. With that, we’re done with vertex B.

Now, the process continues to its next iteration and we extract the minimum element from the priority queue. The minimum element in the priority queue is vertex E. From vertex E, you can reach vertex C in 4 + 4 units of distance, which is more than the current value of **D**(C), 1. This route is not considered as it is clearly proven to be a longer route. With that, we’re done with vertex E.

Now, the process continues to its next iteration and we extract the minimum element from the priority queue. The minimum element in the priority queue is vertex F. You cannot go to any other vertex from vertex F, so, we’re done with vertex F.

With the removal of vertex F, our priority queue becomes empty. So, our algorithm is done…! You can simply return the array **D** to output the shortest paths.

Having got an idea about the overall working of the Dijkstra’s Algorithm, it’s time to look at the pseudo-code –

dijsktra(G, S)
D(S) = 0
Q = G(V)
while (Q != NULL)
u = extractMin(Q)
for all V in adjacencyList[u]
if (D(u) + weight of edge &lt; D(V))
D(V) = D(u) + weight of edge
decreasePriority(Q, V)

In the pseudo-code, **G** is the input graph and **S** is the starting vertex. I hope you understand the pseudo-code. If you don’t, feel free to comment your doubts. Now, before we code Dijkstra’s Algorithm, we must first prepare a tool, which is the Priority Queue.

### The Priority Queue

The Priority Queue is implemented by a number of data structures such as the Binary Heap, Binomial Heap, Fibonacci Heap, etc. The priority queue in my code is implemented by a simple Binary Min Heap. If you are not aware about the Binary Heap, you can refer to my post on Binary Heaps. Now the functionalities that we need from our priority queue are –

**Build Heap** – O(|V|) procedure to construct the heap data structure.
**Extract Min** – O(log |V|) procedure, where we return the top-most element from the Binary Heap and delete it. Finally, we make the necessary changes to the data structure.
**Decrease Key** – We decrease the priority of an element in the priority queue when we find a shorter path, as known as Relaxation.

If you know the working of the Binary Heap you can code the Priority Queue in about 1-2 hours. Alternatively, you can use C++ STL’s priority queue instead. But you don’t have a “decrease key” method there. So, if you want to use C++ STL’s priority queue, instead of removing elements, you can re-insert the same element with the lowered priority value.

## Simple O(|V|^{2}) Implementation

If you choose to implement priority queue simply by using an array, you can achieve the minimum operation in O(N) time. This will give your algorithm a total runtime complexity of O(|V|^{2}). It is the simplest version of Dijkstra’s algorithm. This is the version you are supposed to use if you quickly want to code the Dijkstra’s algorithm for competitive programming, without having to use any fancy data structures. Take a look at the pseudocode again and try to code the algorithm using an array as the priority queue. You can use my code below as a reference –

## Faster O(|E| log |V|) implementation

You can use a binary heap as a priority queue. But remember that to perform the decrease-key operation, you’ll need to know the index of the vertex inside the binary heap array. For that, you’ll need an additional array to store a vertex’s index. Each time any change is made in the binary heap array, corresponding changes must be made in the auxiliary array. Personally, I don’t like this version but I’ll put my code below so that you can use it as a reference.

If you want to do the same thing in C++, you can use a priority queue to reduce a lot. The tweak here is that because you cannot remove a certain vertex from a C++ STL priority queue, we can re-insert it with the new lower priority. This will increase the memory consumption but trust me, its worth it. I have put the codes for both versions below.

C using Binary HeapC++ using STL

The complexity of the above codes is actually O(|V| + |E|) ✗ O(log |V|), which finally makes it O(|E| log |V|). Dijkstra’s Algorithm can be improved by using a Fibonacci Heap as a Priority Queue, where the complexity reduces to O(|V| log |V| + |E|). Because the Fibonacci Heap takes constant time for Decrease Key operation. But the Fibonacci Heap is an incredibly advanced and difficult data structure to code. We’ll talk about that implementation later.

This is the Dijkstra’s Algorithm. If you don’t understand anything or if you have any doubts. Feel free to comment them. I really hope my post has helped you in understanding the Dijkstra’s Algorithm. If it did, let me know by commenting. I tried my best to keep it as simple as possible. Keep practising and… Happy Coding…! 🙂